/*	
 *	d12usr.c
 *
 *	PDIUSBD12 [U[vO
 *	Copyright (c) 1997 Philips Semiconductors
 *	Copyright (c) 2002 Naoyuki Sawa
 *
 *	* Mon Aug 16 12:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33209.h"
#include "d12ci.h"
#include "d12sys.h"

/* ̃\[Xt@ĆAUSB}EX̎łB
 * 쐬USBfoCXƂɏĂB(d12ci,d12sys͕ύXsvł)
 * WfBXNv^WNGXgȂǂ́Â܂܎g邱ƂƎv܂B
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void standard_request(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
void ep1_txdone(int st);

/****************************************************************************
 *	fBXNv^
 ****************************************************************************/

static char ReportDesc[] = {
	0x05,0x01,		// USAGE_PAGE (Generic Desktop)
	0x09,0x02,		// USAGE (Mouse)
	0xa1,0x01,		// COLLECTION (Application)
	0x09,0x01,		//   USAGE (Pointer)
	0xa1,0x00,		//   COLLECTION (Physical)
	0x05,0x09,		//     USAGE_PAGE (Button)
	0x19,0x01,		//     USAGE_MINIMUM (Button 1)
	0x29,0x02,		//     USAGE_MAXIMUM (Button 2)
	0x15,0x00,		//     LOGICAL_MINIMUM (0)
	0x25,0x01,		//     LOGICAL_MAXIMUM (1)
	0x95,0x02,		//     REPORT_COUNT (2)
	0x75,0x01,		//     REPORT_SIZE (1)
	0x81,0x02,		//     INPUT (Data,Var,Abs)
	0x95,0x01,		//     REPORT_COUNT (1)
	0x75,0x06,		//     REPORT_SIZE (6)
	0x81,0x03,		//     INPUT (Cnst,Var,Abs)
	0x05,0x01,		//     USAGE_PAGE (Generic Desktop)
	0x09,0x30,		//     USAGE (X)
	0x09,0x31,		//     USAGE (Y)
	0x15,0x81,		//     LOGICAL_MINIMUM (-127)
	0x25,0x7f,		//     LOGICAL_MAXIMUM (127)
	0x75,0x08,		//     REPORT_SIZE (8)
	0x95,0x02,		//     REPORT_COUNT (2)
	0x81,0x06,		//     INPUT (Data,Var,Rel)
	0xc0,			//   END_COLLECTION
	0xc0,			// END_COLLECTION
};

static unsigned char DeviceDesc[18] = {
	0x12,			// bLength		
	0x01,			// bDescriptorType	foCXfBXNv^
	0x10,0x01,		// bcdUSB		USB Version 1.1
	0x00,			// bDeviceClass		eC^[tF[Xɐݒ
	0x00,			// bDeviceSubClass	gp
	0x00,			// bDeviceProtocol	gp
	EP0_PACKET_SIZE,	// bMaxPacketSize0	EP0̍őpPbgTCY
	0x19,0x0e,		// idVendor		PCE_VENDOR_ID
	0x11,0x10,		// idProduct		PCE_PRODUCT_ID+0x11
	0x00,0x01,		// bcdDevice		foCX[Xԍ 1.10
	0x00,			// iManufacture		gp
	0x00,			// iProduct		gp
	0x00,			// iSerialNumber	gp
	0x01			// bNumConfiguraions	RtBO[V1
};
static unsigned char ConfigDesc[9] = {
	0x09,			// bLength		
	0x02,			// bDescriptorType	RtBO[VfBXNv^
	0x22,0x00,		// wTotalLength		CFG(9)+I/F(9)+HID(9)+EP(7)=34=0x22
	0x01,			// bNumberIntefaces	C^[tF[X1
	0x01,			// bConfigurationValue	RtBO[V1Ȃ̂#1̂
	0x00,			// iConfiguration	gp
	0x80,			// bmAttributes		oXp[foCXA[gEFCNAbv
	0x64			// MaxPower		d 200mA (200/2=100)
};
static unsigned char InterfaceDesc[9] = {
	0x09,			// bLength		
	0x04,			// bDescriptorType	C^[tF[XEfBXNv^
	0x00,			// bInterfaceNumber	C^[tF[X#0
	0x00,			// bAlternateSetting	I^l[gZbg͖
	0x01,			// bNumEndpointes	Gh|Cg1
	0x03,			// bInterfaceClass	HID Class
	0x01,			// bInterfaceSubClass	Boot Interface Subclass (BIOSp? 0ɂ)
	0x02,			// bInterfaceProtocol	Mouse                   (BIOSp? 0ɂ)
	0x00			// iInterface		gp
};
static unsigned char HidDesc[9] = {
	0x09,
	0x21,			// bDescriptorType	HIDfBXNv^
	0x01,0x01,		// bcdHID		HID Version 1.1
	0x00,			// bCountryCode		(not localized)
	0x01,			// bNumDescriptors	NXfBXNv^̎ނ̐(|[gfBXNv^1ނ̂)
	0x22,			// bDescriptorType	1ޖڂ̃NXfBXNv^̎(=|[gfBXNv^)
	sizeof(ReportDesc),0x00,// bDescriptorLength	1ޖڂ̃NXfBXNv^̍vTCY
				// [bDescriptorType]	2ޖڂ̃NXfBXNv^̎()
				// [bDescriptorLength]	2ޖڂ̃NXfBXNv^̍vTCY()
				// ...
};
static unsigned char EndpointDesc[7] = {
	0x07,			// bLength		
	0x05,			// bDescriptorType	Gh|CgfBXNv^
	0x81,			// bEndpointAddress	C^vgIN
	0x03,			// bAttributes		C^vg]
	0x03,0x00,		// wMaxPacketize	]oCg
	0x10,			// bInterval		C^[o[ms]
};

static unsigned char*
dscpy(unsigned char *ptr, const void *src, int len)
{
	memcpy(ptr, src, len);
	return ptr + len;
}

static unsigned char tmpbuff[256]; /* SfBXNv^[ȃTCYKv */

/****************************************************************************
 *	}EX
 ****************************************************************************/

int move_delay;		/* ړJn^C} */
int double_click;	/* _uNbNJEg_E */

/****************************************************************************
 *	WNGXg
 ****************************************************************************/

static void
set_address(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	D12_SetAddressEnable(req->wValue, 1);
	usb_ep0_tx(NULL, 0);
}

static void
get_descriptor(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	unsigned char* p;

	switch(req->wValue & 0xff00) {
	case 0x0100: /* Device */
		/* TODO: */
		usb_ep0_tx(DeviceDesc, sizeof DeviceDesc);
		return;
	case 0x0200: /* Configuration */
		/* TODO: */
		p = tmpbuff;
		p = dscpy(p, ConfigDesc, sizeof ConfigDesc);
		p = dscpy(p, InterfaceDesc, sizeof InterfaceDesc);
		p = dscpy(p, HidDesc, sizeof HidDesc); /* HIDfBXNv^͂̈ʒuƂ܂ */
		p = dscpy(p, EndpointDesc, sizeof EndpointDesc);
		usb_ep0_tx(tmpbuff, p - tmpbuff);
		return;
	case 0x0300: /* String */
	case 0x0400: /* Interface */
	case 0x0500: /* Endpoint */
	case 0x0600: /* Device qualifier */
	case 0x0700: /* Other speed configuration */
	case 0x0800: /* Interface power */
		break; /* Ή */
	case 0x2200: /* Report */
		/* TODO: */
		usb_ep0_tx(ReportDesc, sizeof ReportDesc);
		return;
	}
	usb_ep0_stall();
}

static void
set_configuration(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	D12_SetEndpointEnable(req->wValue != 0);
	usb_ep0_tx(NULL, 0);

	/* ENDPxIN荞݂́A
	 * uobt@łvɔ̂ł͂Ȃuobt@ɂȂvɔ̂ŁA
	 * ̂ݖIɓ]JnKv܂B
	 */
	ep1_txdone(D12_INT_ENDP1IN);
}

static void
set_interface(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	usb_ep0_tx(NULL, 0);
}

static void (*standard_request_table[])(const DEVICE_REQUEST* req, const unsigned char* dat, int len) = {
/* 0*/	NULL/*get_status*/,
/* 1*/	NULL/*clear_feature*/,
/* 2*/	NULL,
/* 3*/	NULL/*set_feature*/,
/* 4*/	NULL,
/* 5*/	set_address,
/* 6*/	get_descriptor,
/* 7*/	NULL/*set_descriptor*/,
/* 8*/	NULL/*get_configuration*/,
/* 9*/	set_configuration,
/*10*/	NULL/*get_interface*/,
/*11*/	set_interface,
/*12*/	NULL/*synch_frame*/,
};
#define N_standard_request_table (sizeof standard_request_table / sizeof *standard_request_table)

/****************************************************************************
 *
 ****************************************************************************/

void
standard_request(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	if(req->bRequest >= N_standard_request_table ||
	   standard_request_table[req->bRequest] == NULL) {
		usb_ep0_stall();
		return;
	}
	standard_request_table[req->bRequest](req, dat, len);
}

void
ep1_txdone(int st)
{
	unsigned char txbuf[3];
	int joy, spd;

	memset(txbuf, 0, 3);
	joy = pcePadGetDirect();

	/* ʏ̃NbN */
	if(joy & PAD_A    ) txbuf[0] |= 1 << 0;
	if(joy & PAD_B    ) txbuf[0] |= 1 << 1;
	/* _uNbN */
	if(double_click > 0 && --double_click == 0) txbuf[0] |= 1 << 0;

	/* J[\ړ */
	spd = joy & PAD_START ? 4 : 2;
	joy &= PAD_LF | PAD_RI | PAD_UP | PAD_DN;
	if(joy == 0) {
		move_delay = 0;
	} else if(joy == (PAD_LF | PAD_RI | PAD_UP | PAD_DN)) { /* _uNbN */
		move_delay = -1; /* SȂƈړJn܂ */
		txbuf[0] |= 1 << 0;
		double_click = 2; /* ㉺E𗣂A2t[ɂǃ{^_E𐶐 */
				  /* 2[DOWN],2[DOWN],...,2[DOWN],1[UP],0[DOWN] ƂȂ܂B        */
	} else {
		if(move_delay != -1) { /* ㉺Eړւ̑Jڂ͖ */
			if(move_delay < 2) {
				/* 2t[x点܂B
				 * (㉺E悤ƂēĂ܂̂邽)
				 */
				move_delay++;
			} else {
				if(joy & PAD_LF) txbuf[1] -= spd;
				if(joy & PAD_RI) txbuf[1] += spd;
				if(joy & PAD_UP) txbuf[2] -= spd;
				if(joy & PAD_DN) txbuf[2] += spd;
			}
		}
	}
	D12_WriteEndpoint(3, txbuf, 3);
}
