/*
 *	main.c
 *
 *	P/ECEAvP[V̐^iCLiPCuŁj
 *
 *	* Tue Jul 23 21:01:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

extern unsigned char PAT[];

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		30			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/* RC */
typedef struct _COIN {
	char type;	/*  */
	char mark;	/* }[N */
} COIN;
/* type */
#define TYPE_1		1	/*   1~ */
#define TYPE_5		2	/*   5~ */
#define TYPE_10		3	/*  10~ */
#define TYPE_50		4	/*  50~ */
#define TYPE_100	5	/* 100~ */
#define TYPE_500	6	/* 500~ */
#define N_TYPES		7
const int chain_count[N_TYPES] = { 0, 5, 2, 5, 2, 5, 2 }; /* Kv`FC */
const int coin_pts[N_TYPES] = { 0, 1, 5, 10, 50, 100, 500 }; /* |Cg */
/* mark */
#define MARK_DOWN	1	/* ~ */
#define MARK_UP		2	/* ㏸ */
#define MARK_ERASE	3	/*  */
#define MARK_RANKUP	4	/* NAbv */
#define MARK_CHECK	5	/* 񗼑֔_ */
#define MARK_OVER	6	/* Q[I[o[ */

/* RCome[u */
const int coin_gen[] = {
	TYPE_1, TYPE_1, TYPE_1, TYPE_1,
	TYPE_5, TYPE_5, TYPE_5,
	TYPE_10, TYPE_10, TYPE_10,
	TYPE_50, TYPE_50, TYPE_50,
	TYPE_100, TYPE_100,
	TYPE_500,
};
#define N_COIN_GEN (sizeof coin_gen / sizeof *coin_gen)

/* Q[(Q[ZbVf[^) */
#define FIELD_COLS	 7		/* tB[h̉ */
#define FIELD_ROWS	(12 + 5)	/* tB[h̏c(ʓ+O) */
#define FIELD_ROWS_LIMIT 12		/* ʓ̃tB[hc */
#define PLAYER_SPEED	4		/* Eړx[sNZ] */
typedef struct _GAMEINFO {
	int score;		/* XRA */
	int level;		/* x */
	int start_time;		/* Jn */
	int change_sum;		/* (xZop) */
	int chain_cnt;		/* ݂̘A */
	int chain_sum;		/* A */
	int chain_max;		/* őA */
	int down_timer;		/* ~^C} */
	/* vC[ */
	int player_phase;	/* tF[Y */
	int player_param;	/* ėpp[^ */
	int player_col;		/* vC[̗ */
	int player_dir;		/* ړp[^(-1ȉ:/1ȏ:E) */
	/* 擾/J */
	int coin_type;		/* 擾/ێ̃RC̎(0:Ȃ) */
	int coin_col;		/* 擾/J̃RC */
	int coin_row;		/* 擾/J̃RCŏs */
	int coin_count;		/* 擾/J̃RC */
	int coin_hold;		/* ێ̃RC */
	/* tB[h */
	int field_phase;	/* tF[Y */
	int field_param;	/* ėpp[^ */
	COIN field[FIELD_ROWS][FIELD_COLS]; /* tB[h */
} GAMEINFO;
/* field_phase */
#define FIELD_NORMAL	0	/* ʏ */
#define FIELD_DOWN	1	/* ~ */
#define FIELD_UP	2	/* ㏸ */
#define FIELD_CHANGE	3	/*  */
/* player_phase */
#define PLAYER_NORMAL	0	/* ʏ */
#define PLAYER_CATCH	1	/* 擾 */
#define PLAYER_RELEASE	2	/* J */

/* x */
typedef struct _LEVEL {
	int down_interval;	/* ~C^[o */
} LEVEL;
const LEVEL levels[] = {
	{ SEC(10) },
	{ SEC( 8) },
	{ SEC( 6) },
	{ SEC( 4) },
	{ SEC( 3) },
	{ SEC( 6) },
	{ SEC( 5) },
	{ SEC( 4) },
	{ SEC( 3) },
	{ SEC( 2) },
	{ SEC( 1) },
};
#define N_LEVELS (sizeof levels / sizeof *levels)

/* OtBbN */
#define FIELD_DX	39	/* tB[h̓]挴_W */
#define FIELD_DY	 2
#define COIN_SX		 0	/* RC̓]_W */
#define COIN_SY		16
#define PLAYER_SX	 0	/* vC[̓]_W */
#define PLAYER_SY	 0
#define ARROW_SX	80	/* ~x̓]_W */
#define ARROW_SY	 0

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

PIECE_BMP pat;				/* ]rbg}bv(Lp) */
PIECE_BMP bg;				/* ]rbg}bv(wip) */

int hiscore;				/* nCXRA */
GAMEINFO gi;				/* Q[ */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void field_disp();
void player_disp();
void player_work();
int mark_fill(int col, int row, int type, int mark, int* col_max, int* row_max);
int up_check();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	srand(pceTimerGetCount());

	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

	/* rbg}bvB */
	texture_init(&pat, PAT);
	bg = pat;			/* wip */
	bg.buf += bg.header.w * 128 / 4;/* wi_ */
	bg.mask = NULL;			/* }XNȂ */
	bg.header.h -= 128;
	bg.header.mask = 0;

	/* N[Abv֐o^B */
	atexit(app_exit);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5)		/* PAUSEbZ[W̉ */
#define PAUSE_H		10		/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	unsigned char save[PAUSE_H][PAUSE_W];

	pause = 0;
	for(;;) {
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */

		/* PAUSEB */
		if(joy & TRG_START) {
			pause ^= 1;	/* PAUSEԐ؂ւ */
			if(pause & 1) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
		if(!(pause & 1)) break;

		/* PAUSEbZ[W_ŕ\B */
		pceFontSetType(PAUSE_FONT);
		pceFontSetTxColor(pause & 2 ? 2 : 3);
		pceFontSetBkColor(pause & 2 ? 0 : 1);
		pceFontSetPos(PAUSE_X, PAUSE_Y);
		pceFontPutStr(PAUSE_STR);
		pause ^= 2;
	}
	now++;	/* O[o^C}XV */

#undef PAUSE_FONT
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int mode, i, x, y, sx, sy, dx, dy;
	unsigned char* p, c;

	mode = 0;
	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_SELECT) return -1;
		if(joy & TRG_A     ) return 0;

		/* \ؑ */
		if(joy & TRG_RI    ) mode = 1;
		if(joy & TRG_LF    ) mode = 0;

		/* ʃNAB */
		p = vbuff;
		c = 1;
		for(y = 0; y < DISP_Y; y++, c ^= 1) {
			for(x = 0; x < DISP_X; x++, c ^= 1) {
				*p++ = c;
			}
		}

		/* FݒB */
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);

		if(mode == 0) {
			/* ^Cg\B */
			pceFontSetType(0x81);
			pceFontSetPos((DISP_X - 8 * 9) / 2, 27);
			pceFontPutStr("EXCHANGER");
			pceFontSetType(0x80);
			pceFontSetPos((DISP_X + 8 * 9) / 2 - 10 * 3, 42);
			pceFontPutStr("ǂ");
		} else {
			pceFontSetType(0x82);
			for(i = 1; i < N_TYPES; i++) {
				sx = COIN_SX + (i - 1) * 8;
				sy = COIN_SY;
				dx = 24 + (i - 1) / 3 * 48;
				dy = 26 + (i - 1) % 3 *  9;
				draw_object(&pat, dx, dy, sx, sy, 8, 8, DRW_NOMAL);
				pceFontSetPos(dx + 12, dy + 2);
				pceFontPrintf("%3d YEN", coin_pts[i]);
			}
		}

		/* XRA\B */
		pceFontSetType(0x82);
		pceFontSetPos(4, 2);
		pceFontPutStr("1P SCORE");
		pceFontSetPos(8, 8);
		pceFontPrintf("%06d", gi.score % 1000000);
		pceFontSetPos(DISP_X - 4 - 4 * 8, 2);
		pceFontPutStr("HI SCORE");
		pceFontSetPos(DISP_X - 8 - 4 * 6, 8);
		pceFontPrintf("%06d", hiscore % 1000000);

		/* vvg\B */
		if(now % SEC(1.0) < SEC(0.67)) {
			pceFontSetType(0x82);
			pceFontSetPos((DISP_X - 4 * 10) / 2, DISP_Y - 4 * 6);
			if(mode == 0) {
				pceFontPutStr(" => COIN INFO");
			} else {
				pceFontPutStr("<=  TITLE");
			}
			pceFontSetPos((DISP_X - 4 * 10) / 2, DISP_Y - 4 * 4);
			pceFontPutStr(" A  START");
			pceFontSetPos((DISP_X - 4 * 10) / 2, DISP_Y - 4 * 2);
			pceFontPutStr("SEL EXIT");
		}
	}

	return 0; /* _~[ */
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	COIN *coin, *coin2;
	int i, chain, change, col, row, col_max, row_max, cnt, spd;

	/* Q[ZbVB */
	memset(&gi, 0, sizeof gi);
	gi.start_time = now;
	gi.player_col = FIELD_COLS / 2;

	/* uREADYv\B */
	for(i = 0; i < SEC(1.5); i++) {
		schedule();
		field_disp();
		if(i % 3 < 2) {
			pceFontSetType(0x80);
			pceFontSetTxColor(3);
			pceFontSetBkColor(-1);
			pceFontSetPos((DISP_X - 5 * 5) / 2, (DISP_Y - 10) / 2);
			pceFontPutStr("READY");
		}
	}

	gi.down_timer = INT_MAX; /* ŏ͂ɉ~ */
	for(;;) {
		/***** ʏ *****/

		chain = 1;
		for(;;) {
			/* ֊Jn */
			change = 0;
			coin = &gi.field[0][0];
			for(row = 0; row < FIELD_ROWS; row++) {
				for(col = 0; col < FIELD_COLS; col++, coin++) {
					if(coin->mark != MARK_CHECK) continue;
					col_max = col;
					row_max = row;
					cnt = mark_fill(col, row, coin->type, MARK_ERASE, &col_max, &row_max);
					if(cnt >= chain_count[(int)coin->type]) {
						gi.field[row_max][col_max].mark = MARK_RANKUP;
						gi.score += coin_pts[(int)coin->type] * cnt; /* XRAZ */
						change++; /* փRC */
					} else {
						mark_fill(col, row, coin->type, 0, NULL, NULL);
					}
				}
			}
			if(change) { /* ֊JnȂAʏ탋[v𔲂܂ */
				/* xZo */
				gi.change_sum += change;
				gi.level = gi.change_sum / 10; /*  */
				break; /* ֏ */
			}
			chain = 0; /* AI */

			/* Q[I[o[ */
			row = FIELD_ROWS_LIMIT;
			coin = &gi.field[row][0];
			for(col = 0; col < FIELD_COLS; col++, coin++) {
				if(coin->type) break;
			}
			if(col < FIELD_COLS) goto GAMEOVER;

			/* ~Jn */
			if(joy & TRG_DN) gi.down_timer = INT_MAX; /* ~ */
			if(gi.down_timer < INT_MAX) gi.down_timer++;
			if(gi.down_timer >= levels[gi.level < N_LEVELS ? gi.level : N_LEVELS - 1].down_interval &&
			   gi.player_phase == PLAYER_NORMAL) {
				/* ~^C}Zbg */
				gi.down_timer = 0;
				/* ̃RCւ炷 */
				coin = &gi.field[FIELD_ROWS - 1][FIELD_COLS - 1];
				for(row = FIELD_ROWS - 1; row >= 1/*2iڂ܂ő*/; row--) {
					for(col = FIELD_COLS - 1; col >= 0; col--, coin--) {
						coin2 = coin - FIELD_COLS;
						coin->type = coin2->type;
						if(coin->type) coin->mark = MARK_DOWN;
						coin2->type = 0; /* ȂĂ */
						coin2->mark = 0; /* ȂĂ */
					}
				}
				/* ŏiɐVRC𐶐 */
				for(col = FIELD_COLS - 1; col >= 0; col--, coin--) {
					coin->type = coin_gen[rand() % N_COIN_GEN];
					coin->mark = MARK_DOWN;
				}
				/* ~Aj[V */
				for(gi.field_param = 1; gi.field_param < 7; gi.field_param++) {
					schedule();
					player_work();
					field_disp();
					player_disp();
				}
				/* ~}[N */
				coin = &gi.field[0][0];
				for(row = 0; row < FIELD_ROWS; row++) {
					for(col = 0; col < FIELD_COLS; col++, coin++) {
						if(coin->mark == MARK_DOWN) coin->mark = 0;
					}
				}
			}

			schedule();
			player_work();
			field_disp();
			player_disp();
		}
		if(!chain) {
			gi.chain_cnt = 0;
		} else {
			gi.chain_cnt++; /* AAbv */
			gi.chain_sum++; /* AvXV */
		}
		if(gi.chain_cnt > gi.chain_max) gi.chain_max = gi.chain_cnt; /* őAXV */

		/*****  *****/

		/* փAj[V */
		for(i = 1/*ŏ̃p^[͒ʏp^[ƓȂ̂Ŕ΂*/ * 2; i < 14 * 2; i++) {
			gi.field_param = i / 2;
			schedule();
			player_work();
			field_disp();
			player_disp();
			if(gi.chain_cnt >= 1) {
				pceFontSetTxColor(i % 3 < 2 ? 3 : 0);
				pceFontSetBkColor(-1);
				pceFontSetType(0x81);
				pceFontSetPos(90, 8);
				pceFontPrintf("%d", gi.chain_cnt % 10);
				pceFontSetType(0x80);
				pceFontSetPos(98, 13);
				pceFontPrintf("");
			}
		}
		/* RC/NAbv */
		coin = &gi.field[0][0];
		for(row = 0; row < FIELD_ROWS; row++) {
			for(col = 0; col < FIELD_COLS; col++, coin++) {
				switch(coin->mark) {
				case MARK_ERASE:
					coin->type = 0;
					coin->mark = 0;
					break;
				case MARK_RANKUP:
					if(coin->type < N_TYPES - 1) {
						coin->type++;
						coin->mark = MARK_CHECK;
					} else {
						coin->type = 0;
						coin->mark = 0;
					}
					break;
				}
			}
		}

		/***** ㏸ *****/

		spd = 1;
		gi.field_param = 0;
		while(up_check()) {
			for( ; gi.field_param < 7; gi.field_param += spd / 2, spd++) {
				schedule();
				player_work();
				field_disp();
				player_disp();
			}
			coin = &gi.field[1/*2iڂ瑖*/][0];
			for(row = 1/*2iڂ瑖*/; row < FIELD_ROWS; row++) {
				for(col = 0; col < FIELD_COLS; col++, coin++) {
					/* ㏸RCֈړB */
					if(coin->mark == MARK_UP) {
						coin2 = coin - FIELD_COLS;
						coin2->type = coin->type;
						coin2->mark = MARK_CHECK;
						coin->type = 0;
						coin->mark = 0;
					}
				}
			}
			gi.field_param -= 7;
		}
	}

GAMEOVER:
	/* Q[I[o[Aj[V */
	coin = &gi.field[0][0];
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++, coin++) {
			if(coin->type) coin->mark = MARK_OVER;
		}
	}
	for(i = 1/*ŏ̃p^[͒ʏp^[ƓȂ̂Ŕ΂*/ * 3; i < 4 * 3; i++) {
		gi.field_param = i / 3;
		schedule();
		field_disp();
	}
	memset(gi.field, 0, sizeof gi.field);
	for(i = 0; i < SEC(3); i++) {
		schedule();
		field_disp();
		pceFontSetType(0x80);
		pceFontSetTxColor(i % 3 < 2 ? 3 : 0);
		pceFontSetBkColor(-1);
		pceFontSetPos((DISP_X - 5 * 9) / 2, (DISP_Y - 10) / 2);
		pceFontPutStr("GAME OVER");
	}

	/* nCXRAXV */
	if(gi.score > hiscore) hiscore = gi.score;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	COIN* coin;
	int col, row, x, y, dx, dy, sx, sy, m, s;

	/* wi */
	draw_object(&bg, 0, 2, 0, 2, 128, 84, DRW_NOMAL);

	/* RC */
	coin = &gi.field[0][0];
	for(row = 0, y = FIELD_DY; row < FIELD_ROWS; row++, y += 7) {
		for(col = 0, x = FIELD_DX; col < FIELD_COLS; col++, x += 7, coin++) {
			if(!coin->type) continue; /*  */
			/* {p^[B */
			dx = x;
			dy = y;
			sx = COIN_SX + (coin->type - 1) * 8;
			sy = COIN_SY;
			/* }[NɂĈʒuƃp^[ωB */
			switch(coin->mark) {
			default:
				/* ێĂRCƓނȂAj[V܂B */
				if(coin->type == gi.coin_type && gi.coin_hold != 0) {
					if(now % SEC(1.0) < SEC(0.25)) sy += 7 * 8;
				}
				break;
			case MARK_DOWN:
				/* 7sNZ`ZʒuցB */
				dy += gi.field_param - 7;
				break;
			case MARK_UP:
				/* Zʒu`7sNZցB */
				dy -= gi.field_param;
				break;
			case MARK_ERASE:
				/* ]܂B */
				sy += (gi.field_param & 3) * 8;
				break;
			case MARK_RANKUP:
				/* c]܂B */
				if(gi.field_param & 3) sy += (3 + (gi.field_param & 3)) * 8;
				break;
			case MARK_OVER:
				/* ȂĂďB */
				if(gi.field_param != 0) {
					sy += (gi.field_param + 6) * 8;
				}
				break;
			}
			/* `B */
			draw_object(&pat, dx, dy, sx, sy, 8, 8, DRW_NOMAL);
		}
	}

	/* Oi */
	draw_object(&bg, 0,  0, 0,  0, 128, 2, DRW_NOMAL);
	draw_object(&bg, 0, 86, 0, 86, 128, 2, DRW_NOMAL);

	/* ~x */
	if(gi.down_timer >= levels[gi.level < N_LEVELS ? gi.level : N_LEVELS - 1].down_interval - SEC(1)) {
		dx = FIELD_DX + (FIELD_COLS / 2) * 7 + 3/*RCS*/ - 7/*󒆐S*/;
		dy = 0;
		sx = ARROW_SX;
		sy = ARROW_SY;
		if(now % SEC(0.3) >= SEC(0.2)) sx += 16;
		draw_object(&pat, dx, dy, sx, sy, 16, 10, DRW_NOMAL);
	}

	/* CtH[V */
	pceFontSetType(0x80);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	/*  */
	pceFontSetPos(2, 16);
	pceFontPrintf("%6d", gi.score % 1000000);
	pceFontSetPos(2, 43);
	pceFontPrintf("%6d", gi.level % 1000000);
	pceFontSetPos(2, 70);
	s = (now - gi.start_time) / FPS;
	m = s / 60;
	s = s % 60;
	pceFontPrintf("%3d'%02d", m % 1000, s % 100);
	/* E */
	pceFontSetPos(91, 43);
	pceFontPrintf("%6d", gi.chain_sum % 1000000);
	pceFontSetPos(91, 70);
	pceFontPrintf("%6d", gi.chain_max % 1000000);
}

/****************************************************************************
 *	player_disp
 ****************************************************************************/

void
player_disp()
{
	int i, dx, dy, sx, sy;

	/* vC[`... */
	dx = FIELD_DX + gi.player_col * 7 + 3/*RCS*/ - 7/*vC[S*/ - gi.player_dir/*ړ*/;
	dy = DISP_Y - 15/*ʉ[*/;
	switch(gi.player_phase) {
	case PLAYER_NORMAL:
		sx = PLAYER_SX + (gi.player_param / 4 & 3) * 16;
		break;
	case PLAYER_CATCH:
	case PLAYER_RELEASE:
		sx = PLAYER_SX + 4 * 16;
		break;
	default:
		sx = 0; /* x} */
		DIE();
	}
	sy = PLAYER_SY;
	/* iɃRCڋ߂AvC[ʒu܂B */
	for(i = 0; i < FIELD_COLS; i++) if(gi.field[FIELD_ROWS_LIMIT - 2][i].type) break;
	if(i < FIELD_COLS) dy += 3;
	for(i = 0; i < FIELD_COLS; i++) if(gi.field[FIELD_ROWS_LIMIT - 1][i].type) break;
	if(i < FIELD_COLS) dy += 3;
	draw_object(&pat, dx, dy, sx, sy, 15, 15, DRW_NOMAL);

	/* 擾/J/ێRC`... */
	if(gi.coin_type) {
		sx = COIN_SX + (gi.coin_type - 1) * 8;
		sy = COIN_SY;
		if(gi.coin_hold) {
			dx = FIELD_DX + gi.player_col * 7 - gi.player_dir/*ړ*/;
			dy = DISP_Y - 8/*ʉ[*/;
			draw_object(&pat, dx, dy, sx, sy, 8, 8, DRW_NOMAL); /* ێ */
		}
		switch(gi.player_phase) {
		case PLAYER_NORMAL:
			break;
		case PLAYER_CATCH:
		case PLAYER_RELEASE:
			dx = FIELD_DX + gi.coin_col * 7;
			dy = FIELD_DY + gi.coin_row * 7;
			for(i = 0; i < gi.coin_count; i++, dy += 7) {
				draw_object(&pat, dx, dy, sx, sy, 8, 8, DRW_NOMAL); /* 擾/J */
			}
			break;
		default:
			sx = 0; /* x} */
			DIE();
		}
	}
}

/****************************************************************************
 *	player_work
 ****************************************************************************/

void
player_work()
{
	COIN* coin;
	int i, col, row, type, cnt, mark;

	/* ړ */
	if(gi.player_dir < 0) { /* ړ */
		gi.player_dir -= PLAYER_SPEED;
		if(gi.player_dir <= -7) gi.player_dir = 0;
	} else if(gi.player_dir > 0) { /* Eړ */
		gi.player_dir += PLAYER_SPEED;
		if(gi.player_dir >= 7) gi.player_dir = 0;
	}

	/* VKړ
	 * ړłc胂[VLZĐVKړJnł܂B
	 */
	if(joy & TRG_LF && 0 < gi.player_col) { /* ړ */
		gi.player_col--;
		gi.player_dir = -PLAYER_SPEED;
	} else if(joy & TRG_RI && gi.player_col < FIELD_COLS - 1) { /* Eړ */
		gi.player_col++;
		gi.player_dir = PLAYER_SPEED;
	}

	/* Aj[VJE^i߂܂B */
	gi.player_param++;

	switch(gi.player_phase) {
	case PLAYER_NORMAL:
		if(joy & TRG_B) {
L10:
			/* 擾\ȃRC̎ނƐ𒲂ׂ܂B */
			col = gi.player_col;
			row = row = FIELD_ROWS - 1;
			type = 0;
			cnt = 0;
			coin = coin = &gi.field[row][col];
			for( ; row >= 0; row--, coin -= FIELD_COLS) {
				if(coin->mark == MARK_ERASE || coin->mark == MARK_RANKUP) goto L20; /* ԉ֒Ȃ܂ */
				type = coin->type;
				if(type) break;
			}
			for( ; row >= 0; row--, coin -= FIELD_COLS) {
				if(coin->mark == MARK_ERASE || coin->mark == MARK_RANKUP) break;
				if(coin->type != type) break;
				cnt++;
			}
			row++;              /* i݂Ă̂Ŗ߂ */
			coin += FIELD_COLS; /* i݂Ă̂Ŗ߂ */
			/* RCARCێĂȂȂ擾ł܂B */
			if(cnt != 0 && (gi.coin_hold == 0 || gi.coin_type == type)) {
				gi.coin_type = type;
				gi.coin_col = col;
				gi.coin_row = row;
				gi.coin_count = cnt;
				gi.player_phase = PLAYER_CATCH;
				/* RC܂B */
				for(i = 0; i < cnt; i++, coin += FIELD_COLS) {
					coin->type = 0;
					coin->mark = 0;
				}
			}
L20:
		} else if(joy & TRG_A) {
			/* ێĂRCAJ܂B */
			if(gi.coin_hold) {
L30:
				/* ʓtB[hŉi`ʊOtB[hŉi̊ԂŁARCJ̏ʒu܂B */
				col = gi.player_col;
				row = FIELD_ROWS_LIMIT - 1;
				coin = &gi.field[row][col];
				while(row < FIELD_ROWS) {
					if(!coin->type) break;
					row++;
					coin += FIELD_COLS;
				}
				if(row < FIELD_ROWS) { /* ԃRCŖ܂ĂAJł܂ */
					gi.coin_col = col;
					gi.coin_row = row;
					gi.coin_count = gi.coin_hold;
					gi.coin_hold = 0;
					gi.player_phase = PLAYER_RELEASE;
				}
			}
		}
		break;
	case PLAYER_CATCH:
		/* ʓtB[hŉiɒBA擾łB */
		gi.coin_row++; /* ֈړ */
		if(gi.coin_row >= FIELD_ROWS_LIMIT - 1 || (joy & (TRG_A | TRG_B))/*[VLZE擾/JJn*/) {
			gi.coin_hold += gi.coin_count;
			gi.coin_count = 0;
			gi.player_phase = PLAYER_NORMAL;
			if(joy & TRG_A) goto L30; /* [VLZEJJn̏ꍇ́AɊJ */
			if(joy & TRG_B) goto L10; /* [VLZE擾Jn̏ꍇ́AɎ擾 */
		}
		break;
	case PLAYER_RELEASE:
		/* tB[hŏiRCɂԂAJłB */
		coin = &gi.field[gi.coin_row][gi.coin_col];
		type = gi.coin_type;
		cnt = gi.coin_count;
		if(joy & TRG_B) { /* [VLZE擾Jn */
			for(;;) {
				if(gi.coin_row == 0 || (coin - FIELD_COLS)->type) break;
				gi.coin_row--;
				coin -= FIELD_COLS;
			}
		}
		if(gi.coin_row == 0 || (coin - FIELD_COLS)->type) {
			if(gi.coin_row > 0 && (coin - FIELD_COLS)->mark == MARK_UP) {
				mark = MARK_UP; /* ̃RCɂƁAɂȂ */
			} else {
				mark = MARK_CHECK; /* łȂ΁AɎ񗼑֔ */
			}
			for(i = 0, row = gi.coin_row; i < gi.coin_count; i++, coin += FIELD_COLS, row++) {
				if(row >= FIELD_ROWS) break;
				coin->type = type;
				coin->mark = mark;
			}
			gi.coin_type = 0;
			gi.coin_count = 0;
			gi.player_phase = PLAYER_NORMAL;
		}
		if(joy & TRG_B) goto L10; /* [VLZE擾Jn̏ꍇ́AɎ擾 */
		gi.coin_row--; /* ֈړBJJnʒuŊ邱Ƃ̂ŁAɈړȂƁI */
		break;
	}
}

/****************************************************************************
 *	mark_fill
 ****************************************************************************/

int
mark_fill(int col, int row, int type, int mark, int* col_max, int* row_max)
{
	COIN* coin;
	int cnt;

	/* ʊOȂJEg܂B */
	if(col < 0 || FIELD_COLS - 1 < col) return 0;
	if(row < 0 || FIELD_ROWS - 1 < row) return 0;

	/* ނႤAɃ}[NĂAJEg܂B */
	coin = &gi.field[row][col];
	if(coin->type != type) return 0;
	if(coin->mark == mark) return 0;

	/* }[NAJEg܂B */
	coin->mark = mark;
	cnt = 1;

	/* EʒuvĂArEi[܂B */
	if(col_max && row_max) {
		if((row > *row_max)/*cD*/ || (row == *row_max && col > *col_max)/*ȂEI*/) {
			*col_max = col;
			*row_max = row;
		}
	}

	/* ㉺EZ̃JEgǉ܂B */
	cnt += mark_fill(col - 1, row, type, mark, col_max, row_max);
	cnt += mark_fill(col + 1, row, type, mark, col_max, row_max);
	cnt += mark_fill(col, row - 1, type, mark, col_max, row_max);
	cnt += mark_fill(col, row + 1, type, mark, col_max, row_max);

	return cnt;
}

/****************************************************************************
 *	up_check
 ****************************************************************************/

int
up_check()
{
	COIN *coin, *coin2;
	int result, col, row;

	result = 0;
	coin = &gi.field[1/*2iڂ瑖*/][0];
	for(row = 1/*2iڂ瑖*/; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++, coin++) {
			if(coin->type) { /* ̃ZɃRC... */
				coin2 = coin - FIELD_COLS;
				if(!coin2->type || coin2->mark == MARK_UP) { /* ̃Z󂩏㏸Ȃ... */
					coin->mark = MARK_UP; /* ̃RC㏸܂ */
					result = 1; /* ړRC */
				}
			}
		}
	}

	return result;
}
